## igstk 4.2.0

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.4)
IF(COMMAND CMAKE_POLICY)
  CMAKE_POLICY(SET CMP0003 NEW)
ENDIF(COMMAND CMAKE_POLICY)

PROJECT( IGSTK )

# version
SET(IGSTK_VERSION_MAJOR "4")
SET(IGSTK_VERSION_MINOR "0")
SET(IGSTK_VERSION_PATCH "0")

SET (LIBRARY_OUTPUT_PATH ${IGSTK_BINARY_DIR}/bin CACHE PATH "Single output directory for building all libraries." FORCE)
SET (EXECUTABLE_OUTPUT_PATH ${IGSTK_BINARY_DIR}/bin CACHE PATH "Single output directory for building all executables." FORCE)

# Build with shared libraries
OPTION(BUILD_SHARED_LIBS "Build with shared libraries" OFF) 

# Add the testing directories
OPTION(IGSTK_BUILD_TESTING "Test the project" ON)

IF(IGSTK_BUILD_TESTING)
  ENABLE_TESTING()
  INCLUDE (${CMAKE_ROOT}/Modules/Dart.cmake)
ENDIF(IGSTK_BUILD_TESTING)

SET(CXX_TEST_PATH ${EXECUTABLE_OUTPUT_PATH})

# Determine if this is development or stable version
OPTION(IGSTK_DEVELOPMENT_VERSION "Set IGSTK version to development" ON)

#
#  FIND ITK
#
FIND_PACKAGE(ITK)
IF (USE_ITK_FILE)
  INCLUDE (${USE_ITK_FILE})
ELSE (USE_ITK_FILE)
  MESSAGE( FATAL_ERROR "This application requires ITK. One of these components is missing. Please verify configuration")
ENDIF (USE_ITK_FILE)

#
# FIND VTK
#
FIND_PACKAGE(VTK)
IF (USE_VTK_FILE)
  INCLUDE (${USE_VTK_FILE})
ELSE (USE_VTK_FILE)
  MESSAGE( FATAL_ERROR "This application requires VTK. One of these components is missing. Please verify configuration")
ENDIF (USE_VTK_FILE)


#
#
#
#  Use the correct ITK & VTK version 
IF( IGSTK_DEVELOPMENT_VERSION )
# development version
   IF( ${ITK_VERSION_MAJOR} LESS 3)
      MESSAGE(FATAL_ERROR "You are using ITK ${ITK_VERSION_MAJOR}.${ITK_VERSION_MINOR}. Use ITK version 3.4 or later")
   ENDIF(${ITK_VERSION_MAJOR} LESS 3 )

   IF( ${ITK_VERSION_MINOR} LESS 4)
      MESSAGE(FATAL_ERROR "You are using ITK ${ITK_VERSION_MAJOR}.${ITK_VERSION_MINOR}. Use ITK version 3.4 or later")
   ENDIF(${ITK_VERSION_MINOR} LESS 4 )

   IF( ${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION} LESS 5.0 )
     MESSAGE(FATAL_ERROR "You are using VTK ${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION}. Use VTK version 5.0 or later")
   ENDIF(${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION} LESS 5.0 )
ELSE( IGSTK_DEVELOPMENT_VERSION ) 
# stable version
   IF( ${ITK_VERSION_MAJOR}.${ITK_VERSION_MINOR} EQUAL 3.8 )
      # correct version
   ELSE( ${ITK_VERSION_MAJOR}.${ITK_VERSION_MINOR} EQUAL 3.8 )
      MESSAGE(FATAL_ERROR "You are using ITK ${ITK_VERSION_MAJOR}.${ITK_VERSION_MINOR}. Use ITK version 3.8")
   ENDIF( ${ITK_VERSION_MAJOR}.${ITK_VERSION_MINOR} EQUAL 3.8)
   IF( ${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION} EQUAL 5.2 )
      # correct version
   ELSE( ${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION} EQUAL 5.2 )
     MESSAGE(FATAL_ERROR "You are using VTK ${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION}. Use VTK version 5.2")
   ENDIF( ${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION} EQUAL 5.2 )
ENDIF( IGSTK_DEVELOPMENT_VERSION ) 

#
# FIND FLTK
#
OPTION(IGSTK_USE_FLTK "Use FLTK (The Fast Light Toolkit) for GUI" OFF)
IF(IGSTK_USE_FLTK)
  FIND_PACKAGE(FLTK)
  IF (FLTK_FOUND)
    INCLUDE_DIRECTORIES (${FLTK_INCLUDE_DIR})
    IF(WIN32)
      ADD_DEFINITIONS(-DWIN32)
    ENDIF(WIN32)
    LINK_LIBRARIES( ${FLTK_LIBRARIES} ${OPENGL_LIBRARIES} )
    IF(CYGWIN)
      LINK_LIBRARIES( ole32 uuid comctl32 wsock32 supc++ -lm -lgdi32)
    ENDIF(CYGWIN)
  ELSE (FLTK_FOUND)
    MESSAGE( FATAL_ERROR "This application requires FLTK. One of these components is missing. Please verify configuration")
  ENDIF (FLTK_FOUND)
ENDIF(IGSTK_USE_FLTK)

#
# FIND Qt
#
OPTION(IGSTK_USE_Qt "Use Qt for GUI" OFF)
IF(IGSTK_USE_Qt)
 # Check if VTK was built with GUISupport on
 IF( NOT VTK_USE_GUISUPPORT )
  MESSAGE(FATAL_ERROR "To build IGSTK with Qt support, you will need to use a VTK
build with GUI support i.e VTK_USE_GUISUPPORT turned on in VTK configuration")
 ENDIF( NOT VTK_USE_GUISUPPORT )

 # Check if VTK was built with Qt on
 IF( NOT VTK_USE_QVTK )
  MESSAGE(FATAL_ERROR "To build IGSTK with Qt support, you will need to use a VTK
build with Qt support i.e VTK_USE_QVTK turned on in VTK configuration")
 ENDIF( NOT VTK_USE_QVTK )
  
 # use what QVTK built with
 SET(QT_QMAKE_EXECUTABLE ${VTK_QT_QMAKE_EXECUTABLE} CACHE FILEPATH "")
 SET(QT_MOC_EXECUTABLE ${VTK_QT_MOC_EXECUTABLE} CACHE FILEPATH "")
 SET(QT_UIC_EXECUTABLE ${VTK_QT_UIC_EXECUTABLE} CACHE FILEPATH "")
 SET(DESIRED_QT_VERSION ${VTK_DESIRED_QT_VERSION} CACHE STRING "")

 IF( DESIRED_QT_VERSION MATCHES 3 )
    MESSAGE( FATAL_ERROR " VTK built using Qt 3. Please use Qt4" )
 ENDIF( DESIRED_QT_VERSION MATCHES 3)

 FIND_PACKAGE(Qt4 REQUIRED)

 IF(QT_USE_FILE)
   INCLUDE(${QT_USE_FILE})
 ELSE(QT_USE_FILE)
   SET(QT_LIBRARIES   ${QT_QT_LIBRARY})
 ENDIF(QT_USE_FILE)

 INCLUDE_DIRECTORIES (${QT_INCLUDE_DIR})

ENDIF(IGSTK_USE_Qt)

# The IGSTK Library
SUBDIRS(Source)

# Add the testing directories
IF(IGSTK_BUILD_TESTING)
   SUBDIRS(Testing)
ENDIF(IGSTK_BUILD_TESTING)

# Add the examples directories
OPTION(IGSTK_BUILD_EXAMPLES "Examples of the project" ON)
IF(IGSTK_BUILD_EXAMPLES)
   SUBDIRS(Examples)
ENDIF(IGSTK_BUILD_EXAMPLES)

# Connect MicronTracker
OPTION(IGSTK_USE_MicronTracker "Connect MicronTracker" OFF)

IF(IGSTK_USE_MicronTracker)
  FIND_PATH(MTC_INCLUDE_DIRECTORY MTC.h
  "C:/Program Files/Claron Technology/MicronTracker/Dist"
  DOC "Directory where the MTC.h file is located")
  INCLUDE_DIRECTORIES( ${MTC_INCLUDE_DIRECTORY} )
  INCLUDE_DIRECTORIES( ${IGSTK_SOURCE_DIR}/Utilities/MicronTracker/src )

  FIND_LIBRARY( MTC_LIBRARY 
    NAMES MTC MTC.dll 
    PATHS "C:/Program Files/Claron Technology/MicronTracker/Dist"
    DOC "Full path to the MTC.dll file"
    )

  IF(MTC_INCLUDE_DIRECTORY)
   INCLUDE(${IGSTK_SOURCE_DIR}/CMake/ExtractMTCVersion.cmake)
    IF( ${MTCMajorVersion}.${MTCMinorVersion} LESS 2.6 )
      MESSAGE( FATAL_ERROR " Your MTC version is
  ${MTCMajorVersion}.${MTCMinorVersion}. Version 2.6 or later should be used")
    ENDIF( ${MTCMajorVersion}.${MTCMinorVersion} LESS 2.6 )
    
    GET_FILENAME_COMPONENT( MTC_LIBRARY_DIRS ${MTC_LIBRARY} PATH )
    LINK_DIRECTORIES( ${MTC_LIBRARY_DIRS} )
  ENDIF(MTC_INCLUDE_DIRECTORY)
ENDIF(IGSTK_USE_MicronTracker)

#
# Use OpenIGTLink protocol 
#
OPTION(IGSTK_USE_OpenIGTLink "Use the OpenIGTLink protocol" OFF)
IF(IGSTK_USE_OpenIGTLink)
  #
  #  FIND OpenIGTLink 
  #
  FIND_PACKAGE(OpenIGTLink)
  IF (OpenIGTLink_USE_FILE)
    INCLUDE (${OpenIGTLink_USE_FILE})
  ELSE (OpenIGTLink_USE_FILE)
    MESSAGE( FATAL_ERROR "This application requires OpenIGTLink. One of these components is missing. Please verify configuration")
  ENDIF (OpenIGTLink_USE_FILE)
ENDIF(IGSTK_USE_OpenIGTLink)

#
# Use OpenCV 
#
OPTION(IGSTK_USE_OpenCV "Use the OpenCV library" OFF)
IF(IGSTK_USE_OpenCV)
  #
  #  FIND OpenCV 
  FIND_PACKAGE( OpenCV REQUIRED )
ENDIF(IGSTK_USE_OpenCV)


#
# This option enables the scene graph observer to collect relavant events to constuct the scene graph tree
#
OPTION(IGSTK_USE_SceneGraphVisualization "Enable scene graph visualization by allowing the observer to listen to relevant events" ON)
IF(IGSTK_USE_SceneGraphVisualization)
  INCLUDE_DIRECTORIES( ${IGSTK_SOURCE_DIR}/Utilities/SceneGraphVisualization )
ENDIF(IGSTK_USE_SceneGraphVisualization)

#-----------------------------------------------------------------------------
# IGSTK build video imager classes
OPTION(IGSTK_USE_VideoImager "Build video imager classes are under review and not fully tested yet" OFF)

IF(IGSTK_USE_VideoImager)
  MESSAGE("Warning: Video imager classes are under review and not fully tested yet") 
ENDIF(IGSTK_USE_VideoImager)

#-----------------------------------------------------------------------------
# Configure the default IGSTK_DATA_ROOT for the location of IGSTK Data.
FIND_PATH(IGSTK_DATA_ROOT igstkDataReadMe.txt ${IGSTK_SOURCE_DIR}/Testing/Data $ENV{IGSTK_DATA_ROOT})
MARK_AS_ADVANCED(IGSTK_DATA_ROOT)

#-----------------------------------------------------------------------------
# The entire IGSTK tree should use the same include path, except for the
# Wrapping directory.

# Create the list of include directories needed for IGSTK header files.
INCLUDE(${IGSTK_SOURCE_DIR}/igstkIncludeDirectories.cmake)

# This should be the only INCLUDE_DIRECTORIES command in the entire
# tree, except for the Utilities and Wrapping directories.  We need to
# do this in one place to make sure the order is correct.
INCLUDE_DIRECTORIES(
  ${ITK_DIR}/Utilities/zlib
  ${IGSTK_INCLUDE_DIRS_BUILD_TREE}
  ${IGSTK_INCLUDE_DIRS_BUILD_TREE_CXX}
  ${IGSTK_INCLUDE_DIRS_SYSTEM}
)

#-----------------------------------------------------------------------------
# check for header files that we need
INCLUDE (${CMAKE_ROOT}/Modules/CheckIncludeFile.cmake)
# for serial communication: termio.h or termios.h?
CHECK_INCLUDE_FILE("termios.h"       HAVE_TERMIOS_H)
CHECK_INCLUDE_FILE("termio.h"        HAVE_TERMIO_H)

# Configure a header needed by igstkSystemInformation.
CONFIGURE_FILE("${IGSTK_SOURCE_DIR}/igstkConfigure.h.in"
               "${IGSTK_BINARY_DIR}/igstkConfigure.h")

#-----------------------------------------------------------------------------
# Help other projects use IGSTK.
SET(IGSTK_LIBRARY_PATH ${LIBRARY_OUTPUT_PATH})


# Copy the UseIGSTK.cmake file to the binary tree for backward compatability.
CONFIGURE_FILE(${IGSTK_SOURCE_DIR}/UseIGSTK.cmake.in
               ${IGSTK_BINARY_DIR}/UseIGSTK.cmake COPYONLY IMMEDIATE)

# Save the compiler settings so another project can import them.
INCLUDE(${CMAKE_ROOT}/Modules/CMakeExportBuildSettings.cmake)
CMAKE_EXPORT_BUILD_SETTINGS(${IGSTK_BINARY_DIR}/IGSTKBuildSettings.cmake)

#-----------------------------------------------------------------------------
# Installation vars.
# IGSTK_INSTALL_BIN_DIR          - binary dir (executables)
# IGSTK_INSTALL_LIB_DIR          - library dir (libs)
# IGSTK_INSTALL_DATA_DIR         - share dir (say, examples, data, etc)
# IGSTK_INSTALL_INCLUDE_DIR      - include dir (headers)
# IGSTK_INSTALL_PACKAGE_DIR      - package/export configuration files

IF(NOT IGSTK_INSTALL_BIN_DIR)
   SET(IGSTK_INSTALL_BIN_DIR
      ${CMAKE_INSTALL_PREFIX}/bin
   )
ENDIF(NOT IGSTK_INSTALL_BIN_DIR)

IF(NOT IGSTK_INSTALL_LIB_DIR)
   SET(IGSTK_INSTALL_LIB_DIR
      ${CMAKE_INSTALL_PREFIX}/lib/IGSTK
   )
ENDIF(NOT IGSTK_INSTALL_LIB_DIR)

IF(NOT IGSTK_INSTALL_DATA_DIR)
   SET(IGSTK_INSTALL_DATA_DIR
      ${CMAKE_INSTALL_PREFIX}/share/IGSTK
   )
ENDIF(NOT IGSTK_INSTALL_DATA_DIR)

IF(NOT IGSTK_INSTALL_INCLUDE_DIR)
   SET(IGSTK_INSTALL_INCLUDE_DIR
      ${CMAKE_INSTALL_PREFIX}/include/IGSTK
   )
ENDIF(NOT IGSTK_INSTALL_INCLUDE_DIR)

IF(NOT IGSTK_INSTALL_PACKAGE_DIR)
   SET(IGSTK_INSTALL_PACKAGE_DIR
      ${IGSTK_INSTALL_LIB_DIR}
#      CACHE INTERNAL ""
   )
ENDIF(NOT IGSTK_INSTALL_PACKAGE_DIR)


# Save library dependencies.
EXPORT_LIBRARY_DEPENDENCIES(${IGSTK_BINARY_DIR}/IGSTKLibraryDepends.cmake)

# Create the IGSTKConfig.cmake file containing the IGSTK configuration.
INCLUDE (${IGSTK_SOURCE_DIR}/igstkGenerateIGSTKConfig.cmake)

# Install some files.
INSTALL(FILES
   ${IGSTK_BINARY_DIR}/igstkConfigure.h 
   DESTINATION ${IGSTK_INSTALL_INCLUDE_DIR}
)

INSTALL(FILES
   ${IGSTK_BINARY_DIR}/IGSTKBuildSettings.cmake
   ${IGSTK_BINARY_DIR}/IGSTKLibraryDepends.cmake
   ${IGSTK_BINARY_DIR}/UseIGSTK.cmake
   DESTINATION ${IGSTK_INSTALL_PACKAGE_DIR}
)

#-----------------------------------------------------------------------------
# Set up CPack support, to be able to distribute IGSTK 
#
INCLUDE(InstallRequiredSystemLibraries)
SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "IGSTK ")
SET(CPACK_PACKAGE_VENDOR "ISC")
SET(CPACK_PACKAGE_VERSION_MAJOR "${IGSTK_VERSION_MAJOR}")
SET(CPACK_PACKAGE_VERSION_MINOR "${IGSTK_VERSION_MINOR}")
SET(CPACK_PACKAGE_VERSION_PATCH "${IGSTK_VERSION_PATCH}")
SET(CPACK_PACKAGE_INSTALL_DIRECTORY "IGSTK-${IGSTK_VERSION_MAJOR}.${IGSTK_VERSION_MINOR}")
INCLUDE(CPack)


#-----------------------------------------------------------------------------
# Add compiler flags IGSTK needs to work on this platform.  This must be
# done AFTER the call to CMAKE_EXPORT_BUILD_SETTINGS.

=== Examples/CMakeLists.txt ===
#
# Examples that do not require GUI
#

SUBDIRS(
 TransformReaders
 TransformWriters
 TrackerConfiguration
 Tools
)



#
# Examples that require FLTK
#
IF(IGSTK_USE_FLTK)
  SUBDIRS(
    HelloWorld
    OneViewAndTracking
    FourViewsAndTracking
    TrackingVolumeViewer 
    NeedleBiopsy
    Navigator
    PivotCalibrationFLTKWidget
   )

   IF(IGSTK_USE_MicronTracker)
     SUBDIRS(OneViewAndTrackingUsingMicronTracker)
   ENDIF(IGSTK_USE_MicronTracker)
ENDIF(IGSTK_USE_FLTK)

IF(IGSTK_USE_Qt)
   IF(IGSTK_USE_MicronTracker)
     SUBDIRS(OneViewAndTrackingUsingQTWidgetAndMicronTracker)
   ENDIF(IGSTK_USE_MicronTracker)
ENDIF(IGSTK_USE_Qt)

IF (IGSTK_USE_OpenIGTLink)
    SUBDIRS(  OpenIGTLinkTrackerBroadcasting )
    SUBDIRS(  OpenIGTLinkConfigurationReaders )
ENDIF (IGSTK_USE_OpenIGTLink)


IF(IGSTK_USE_VideoImager)
 IF( WIN32 )
   IF (IGSTK_USE_OpenCV)
      SUBDIRS( VideoFrameGrabberAndViewerWebcam )
   ENDIF (IGSTK_USE_OpenCV)
 ENDIF( WIN32 )

 IF(IGSTK_USE_OpenIGTLink)
  SUBDIRS( VideoFrameGrabberAndViewerOpenIGTLink )
 ENDIF(IGSTK_USE_OpenIGTLink)

ENDIF(IGSTK_USE_VideoImager)

=== Source/CMakeLists.txt ===
#
#  Define the list of source files forming the IGSTK Library
#
# The header files

SET(IGSTK_HEADS
  igstkUSImageObject.h
  igstkUSImageObjectRepresentation.h
  igstkUSImageReader.h
  igstkAnnotation2D.h
  igstkAxesObject.h
  igstkAxesObjectRepresentation.h
  igstkBoxObject.h
  igstkBoxObjectRepresentation.h
  igstkConeObject.h
  igstkConeObjectRepresentation.h
  igstkImageReader.h
  igstkDICOMImageReader.h
  igstkCTImageReader.h
  igstkMRImageReader.h
  igstkImageSpatialObject.h
  igstkCTImageSpatialObject.h
  igstkMRImageSpatialObject.h
  igstkImageSpatialObjectRepresentation.h
  igstkCTImageSpatialObjectRepresentation.h
  igstkMRImageSpatialObjectRepresentation.h
  igstkLandmark3DRegistration.h
  igstkLandmark3DRegistrationErrorEstimator.h
  igstkAuroraTracker.h
  igstkAuroraTrackerTool.h
  igstkBinaryData.h
  igstkCommunication.h
  igstkCylinderObject.h
  igstkCylinderObjectRepresentation.h
  igstkEllipsoidObject.h  
  igstkEllipsoidObjectRepresentation.h  
  igstkEvents.h
  igstkMacros.h
  igstkMeshObject.h
  igstkMeshObjectRepresentation.h
  igstkMultipleOutput.h
  igstkNDICommandInterpreter.h
  igstkNDIErrorEvent.h
  igstkObjectRepresentation.h
  igstkObject.h
  igstkPolarisTracker.h
  igstkPolarisTrackerTool.h
  igstkPulseGenerator.h
  igstkRenderWindowInteractor.h
  igstkRealTimeClock.h
  igstkSerialCommunication.h
  igstkSerialCommunicationSimulator.h
  igstkSpatialObject.h
  igstkStateMachine.h
  igstkStateMachineInput.h
  igstkStateMachineState.h
  igstkTimeStamp.h
  igstkTransform.h
  igstkTransformBase.h
  igstkToken.h
  igstkTracker.h
  igstkTrackerTool.h
  igstkTubeObject.h
  igstkTubeObjectRepresentation.h
  igstkUltrasoundProbeObject.h
  igstkUltrasoundProbeObjectRepresentation.h
  igstkVTKLoggerOutput.h
  igstkSpatialObjectReader.h
  igstkTubeReader.h
  igstkMeshReader.h
  igstkGroupObject.h
  igstkLogger.h
  igstkCoordinateSystem.h
  igstkCoordinateSystemDelegator.h
  igstkCoordinateSystemTransformToResult.h
  igstkCoordinateSystemTransformToErrorResult.h
  igstkCoordinateSystemInterfaceMacros.h
  igstkCoordinateSystemSetTransformResult.h

  igstkCircularSimulatedTracker.h
  igstkSimulatedTrackerTool.h
  igstkSimulatedTracker.h
  igstkNDITracker.h

  igstkAffineTransform.h
  igstkPerspectiveTransform.h

  igstkView.h
  igstkView2D.h
  igstkView3D.h

# Ascension tracker support
  igstkAscensionCommandInterpreter.h
  igstkAscensionTracker.h
  igstkAscensionTrackerTool.h

# Reslicing component support
  igstkReslicerPlaneSpatialObject.h
  igstkToolProjectionSpatialObject.h
  igstkToolProjectionObjectRepresentation.h
  igstkMeshResliceObjectRepresentation.h
  igstkImageResliceObjectRepresentation.h

  igstkCrossHairSpatialObject.h
  igstkCrossHairObjectRepresentation.h

  igstkPivotCalibrationAlgorithm.h

  igstkPivotCalibration.h
)

IF(IGSTK_USE_FLTK)
  SET(IGSTK_HEADS
    ${IGSTK_HEADS}
    igstkFLTKTextBufferLogOutput.h
    igstkFLTKTextLogOutput.h
    igstkMouseTracker.h
    igstkMouseTrackerTool.h
    igstkFLTKWidget.h
    igstkPivotCalibrationFLTKWidget.h
    )
ENDIF(IGSTK_USE_FLTK)

IF(IGSTK_USE_Qt)
  SET(IGSTK_HEADS
      ${IGSTK_HEADS}
      igstkQMouseTracker.h
      igstkQMouseTrackerTool.h
      igstkQTWidget.h
   )
ENDIF(IGSTK_USE_Qt)

IF(IGSTK_USE_MicronTracker)
  SET(IGSTK_HEADS
      ${IGSTK_HEADS}
      igstkMicronTracker.h
      igstkMicronTrackerTool.h
     )
ENDIF(IGSTK_USE_MicronTracker)


IF(IGSTK_USE_OpenIGTLink)
    SET(IGSTK_HEADS
      ${IGSTK_HEADS}
      igstkTrackerToolObserverToOpenIGTLinkRelay.h
      )
ENDIF(IGSTK_USE_OpenIGTLink)

IF(IGSTK_USE_VideoImager)
    SET(IGSTK_HEADS
        ${IGSTK_HEADS}
        igstkVideoImager.h
        igstkVideoImagerTool.h
        igstkFrame.h
        igstkVideoFrameSpatialObject.h
        igstkVideoFrameRepresentation.h
        )

  IF(IGSTK_USE_OpenIGTLink)
    SET(IGSTK_HEADS
       ${IGSTK_HEADS}
       igstkOpenIGTLinkVideoImager.h
       igstkOpenIGTLinkVideoImagerTool.h
       )
  ENDIF(IGSTK_USE_OpenIGTLink)

  IF(WIN32)
    IF(IGSTK_USE_OpenCV)
      SET(IGSTK_HEADS
        ${IGSTK_HEADS}
        igstkWebcamWinVideoImager.h
        igstkWebcamWinVideoImagerTool.h
        )
    ENDIF(IGSTK_USE_OpenCV)
  ENDIF(WIN32)

ENDIF(IGSTK_USE_VideoImager)

# The implementation files

SET(IGSTK_SRCS  
  igstkUSImageObject.cxx
  igstkUSImageObjectRepresentation.cxx
  igstkUSImageReader.cxx
  igstkMR3DImageToUS3DImageRegistration.cxx
  igstkAnnotation2D.cxx
  igstkAxesObject.cxx
  igstkAxesObjectRepresentation.cxx
  igstkBoxObject.cxx
  igstkBoxObjectRepresentation.cxx
  igstkConeObject.cxx
  igstkConeObjectRepresentation.cxx
  igstkImageReader.txx
  igstkDICOMImageReader.txx
  igstkCTImageReader.cxx
  igstkMRImageReader.cxx
  igstkImageSpatialObject.txx
  igstkCTImageSpatialObject.cxx
  igstkMRImageSpatialObject.cxx
  igstkImageSpatialObjectRepresentation.txx
  igstkCTImageSpatialObjectRepresentation.cxx
  igstkMRImageSpatialObjectRepresentation.cxx
  igstkLandmark3DRegistration.cxx
  igstkLandmark3DRegistrationErrorEstimator.cxx
  igstkAuroraTracker.cxx
  igstkAuroraTrackerTool.cxx
  igstkBinaryData.cxx
  igstkCommunication.cxx
  igstkCylinderObject.cxx
  igstkCylinderObjectRepresentation.cxx
  igstkEllipsoidObject.cxx
  igstkEllipsoidObjectRepresentation.cxx
  igstkMeshObject.cxx
  igstkMeshObjectRepresentation.cxx
  igstkMultipleOutput.cxx
  igstkNDICommandInterpreter.cxx
  igstkObject.cxx
  igstkObjectRepresentation.cxx
  igstkPolarisTracker.cxx
  igstkPolarisTrackerTool.cxx
  igstkPulseGenerator.cxx
  igstkRenderWindowInteractor.cxx
  igstkRealTimeClock.cxx
  igstkSerialCommunication.cxx
  igstkSerialCommunicationSimulator.cxx
  igstkSpatialObject.cxx
  igstkStateMachine.txx
  igstkTimeStamp.cxx
  igstkToken.cxx
  igstkTracker.cxx
  igstkTrackerTool.cxx
  igstkTransform.cxx
  igstkTransformBase.cxx
  igstkTubeObject.cxx
  igstkTubeObjectRepresentation.cxx
  igstkUltrasoundProbeObject.cxx
  igstkUltrasoundProbeObjectRepresentation.cxx
  igstkVTKLoggerOutput.cxx
  igstkTubeReader.cxx
  igstkMeshReader.cxx
  igstkGroupObject.cxx
  igstkLogger.cxx
  igstkCoordinateSystem.cxx
  igstkCoordinateSystemDelegator.cxx
  igstkCoordinateSystemTransformToResult.cxx
  igstkCoordinateSystemTransformToErrorResult.cxx
  igstkCoordinateSystemSetTransformResult.cxx

  igstkCircularSimulatedTracker.cxx
  igstkSimulatedTrackerTool.cxx
  igstkSimulatedTracker.cxx
  igstkNDITracker.cxx

  igstkAffineTransform.cxx
  igstkPerspectiveTransform.cxx

  igstkView.cxx
  igstkView2D.cxx
  igstkView3D.cxx
  igstkViewProxyBase.cxx

# Ascension tracker support
  igstkAscensionCommandInterpreter.cxx
  igstkAscensionTracker.cxx
  igstkAscensionTrackerTool.cxx

# Reslicing component support
  igstkReslicerPlaneSpatialObject.cxx

  igstkToolProjectionSpatialObject.cxx
  igstkToolProjectionObjectRepresentation.cxx
  igstkMeshResliceObjectRepresentation.cxx
  igstkImageResliceObjectRepresentation.txx
  igstkCrossHairSpatialObject.cxx
  igstkCrossHairObjectRepresentation.cxx

  igstkPivotCalibrationAlgorithm.cxx

  igstkPivotCalibration.cxx
)

IF(IGSTK_USE_FLTK)
  SET(IGSTK_SRCS  
    ${IGSTK_SRCS}
    igstkFLTKTextBufferLogOutput.cxx
    igstkFLTKTextLogOutput.cxx
    igstkMouseTracker.cxx
    igstkMouseTrackerTool.cxx
    igstkFLTKWidget.cxx
    igstkPivotCalibrationFLTKWidget.cxx
    )
ENDIF(IGSTK_USE_FLTK)

IF(IGSTK_USE_Qt)
  SET(IGSTK_SRCS
      ${IGSTK_SRCS}
      igstkQMouseTracker.cxx
      igstkQMouseTrackerTool.cxx
      igstkQTWidget.cxx
   )
ENDIF(IGSTK_USE_Qt)

IF(IGSTK_USE_MicronTracker)
  SET(IGSTK_SRCS
      ${IGSTK_SRCS}
      igstkMicronTracker.cxx
      igstkMicronTrackerTool.cxx
 
     )
ENDIF(IGSTK_USE_MicronTracker)

IF(IGSTK_USE_OpenIGTLink)
    SET(IGSTK_SRCS
      ${IGSTK_SRCS}
      igstkTrackerToolObserverToOpenIGTLinkRelay.cxx
      )
ENDIF(IGSTK_USE_OpenIGTLink)

IF(IGSTK_USE_VideoImager)
    SET(IGSTK_SRCS
        ${IGSTK_SRCS}
        igstkVideoImager.cxx
        igstkVideoImagerTool.cxx
        igstkFrame.cxx
        igstkVideoFrameSpatialObject.txx
        igstkVideoFrameRepresentation.txx
        )

  IF(IGSTK_USE_OpenIGTLink)
    SET(IGSTK_SRCS
       ${IGSTK_SRCS}
       igstkOpenIGTLinkVideoImager.cxx
       igstkOpenIGTLinkVideoImagerTool.cxx
       )
  ENDIF(IGSTK_USE_OpenIGTLink)

  IF(WIN32)
    IF(IGSTK_USE_OpenCV)
      SET(IGSTK_SRCS
        ${IGSTK_SRCS}
        igstkWebcamWinVideoImager.cxx
        igstkWebcamWinVideoImagerTool.cxx
        )
    ENDIF(IGSTK_USE_OpenCV)    
  ENDIF(WIN32)

ENDIF(IGSTK_USE_VideoImager)


IF( WIN32 )
  SET(IGSTK_HEADS ${IGSTK_HEADS} 
    igstkSerialCommunicationForWindows.h
  )
  SET(IGSTK_SRCS ${IGSTK_SRCS} 
    igstkSerialCommunicationForWindows.cxx
  )
ELSE( WIN32 )
  SET(IGSTK_HEADS ${IGSTK_HEADS} 
    igstkSerialCommunicationForPosix.h
  )
  SET(IGSTK_SRCS ${IGSTK_SRCS} 
    igstkSerialCommunicationForPosix.cxx
  )
ENDIF( WIN32 )

# Variable for holding extra libraries
SET(EXTRA_LIBS)
IF(IGSTK_USE_Qt)
  IF(APPLE)
   SET(EXTRA_LIBS ${EXTRA_LIBS} QVTK  "-framework QtTest")
  ELSE(APPLE)
    SET(EXTRA_LIBS ${EXTRA_LIBS} QVTK  ${QT_QTTEST_LIBRARY})
  ENDIF(APPLE)
ENDIF(IGSTK_USE_Qt)

IF(IGSTK_USE_MicronTracker)
  SET(EXTRA_LIBS ${EXTRA_LIBS} igstkMTCu)
   
  IF(WIN32)
    SET(EXTRA_LIBS ${EXTRA_LIBS}  comctl32 wsock32 odbc32 odbccp32 )
  ELSE(WIN32)
    SET(EXTRA_LIBS ${EXTRA_LIBS} raw1394 dc1394_control )
  ENDIF(WIN32)
  
ENDIF(IGSTK_USE_MicronTracker)

IF(IGSTK_USE_OpenIGTLink)
  SET(EXTRA_LIBS ${EXTRA_LIBS} OpenIGTLink)
ENDIF(IGSTK_USE_OpenIGTLink)

IF(IGSTK_USE_SceneGraphVisualization)
  SET(EXTRA_LIBS ${EXTRA_LIBS} SceneGraphVisualization)
ENDIF(IGSTK_USE_SceneGraphVisualization)

IF(IGSTK_USE_OpenCV)
  SET(EXTRA_LIBS ${EXTRA_LIBS} cxcore110 cv110 highgui110)
ENDIF(IGSTK_USE_OpenCV)


# Adding the IGSTK library

ADD_LIBRARY(IGSTK ${IGSTK_HEADS} ${IGSTK_SRCS})

# Linking with the FLTK, ITK and VTK libraries
TARGET_LINK_LIBRARIES( IGSTK
    ITKIO ITKBasicFilters ITKNumerics ITKCommon ITKSpatialObject
    vtkRendering vtkGraphics vtkHybrid vtkImaging 
    vtkIO vtkFiltering vtkCommon vtksys
    ${EXTRA_LIBS}
)

SET_TARGET_PROPERTIES(IGSTK PROPERTIES
#   BUILD_WITH_INSTALL_RPATH OFF
#   INSTALL_RPATH ${CMAKE_INSTALL_PREFIX}/lib
#   INSTALL_NAME_DIR ${CMAKE_INSTALL_PREFIX}/lib
   VERSION ${IGSTK_VERSION_MAJOR}.${IGSTK_VERSION_MINOR}.${IGSTK_VERSION_PATCH}
   SOVERSION ${IGSTK_VERSION_MAJOR}
)

IF(IGSTK_USE_FLTK)
  TARGET_LINK_LIBRARIES( IGSTK ${FLTK_LIBRARIES} )
ENDIF(IGSTK_USE_FLTK)

INSTALL(TARGETS IGSTK
   DESTINATION ${IGSTK_INSTALL_LIB_DIR}
)

FILE(GLOB __files1 "${CMAKE_CURRENT_SOURCE_DIR}/*.h")
FILE(GLOB __files2 "${CMAKE_CURRENT_SOURCE_DIR}/*.txx")

INSTALL(FILES ${__files1} ${__files2}
   DESTINATION ${IGSTK_INSTALL_INCLUDE_DIR}
)

=== Testing/CMakeLists.txt ===
#Options for devices attached to serial port for testing
OPTION(IGSTK_TEST_AURORA_ATTACHED "Aurora is attached to computer" OFF)
SET( IGSTK_TEST_AURORA_PORT_NUMBER 0 CACHE STRING
     "Serial port number (0, 1, 2, 3)" )
OPTION(IGSTK_TEST_POLARIS_ATTACHED "Polaris is attached to computer" OFF)
SET( IGSTK_TEST_POLARIS_PORT_NUMBER 0 CACHE STRING
     "Serial port number (0, 1, 2, 3)" )
OPTION(IGSTK_TEST_LOOPBACK_ATTACHED "Serial Loopback is attached" OFF)
SET( IGSTK_TEST_LOOPBACK_PORT_NUMBER 1 CACHE STRING
     "Serial port number (0, 1, 2, 3)" )

OPTION(IGSTK_TEST_FLOCKOFBIRD_ATTACHED "Flock of birds is attached to computer" OFF)
SET( IGSTK_TEST_FLOCKOFBIRD_PORT_NUMBER 0 CACHE STRING
     "Serial port number (0, 1, 2, 3)" )

INCLUDE_DIRECTORIES (
  ${IGSTK_SOURCE_DIR}
  ${IGSTK_BINARY_DIR}
  ${IGSTK_SOURCE_DIR}/Source
  ${IGSTK_BINARY_DIR}/Source
  ${IGSTK_SOURCE_DIR}/Testing
  ${IGSTK_BINARY_DIR}/Testing
  )

#Include the cmake file that contains the testing macro. Add new tests
#in IGSTKTestingMacros file.
INCLUDE(${IGSTK_SOURCE_DIR}/Testing/IGSTKTestingMacros.cmake)

#invoke the macro with the appropriatae arguments 
SET(SANDBOX_BUILD 0)
IGSTKTesting(igstkTests
             IGSTK
             ${SANDBOX_BUILD}
             ${IGSTK_DATA_ROOT}
             ${IGSTK_BINARY_DIR}
             IGSTK_TEST_AURORA_ATTACHED
             ${IGSTK_TEST_AURORA_PORT_NUMBER}
             IGSTK_TEST_POLARIS_ATTACHED
             ${IGSTK_TEST_POLARIS_PORT_NUMBER}
             IGSTK_TEST_LOOPBACK_ATTACHED
             ${IGSTK_TEST_LOOPBACK_PORT_NUMBER}
             IGSTK_USE_FLTK
             IGSTK_USE_Qt
             IGSTK_USE_MicronTracker
             IGSTK_USE_KWSTYLE
             IGSTK_TEST_FLOCKOFBIRD_ATTACHED
             ${IGSTK_TEST_FLOCKOFBIRD_PORT_NUMBER}
             IGSTK_USE_OpenIGTLink
             IGSTK_USE_VideoImager
             )

=== Examples/OpenIGTLinkConfigurationReaders/CMakeLists.txt ===
PROJECT(OpenIGTLinkConfigurationReaders)
  
SET(PRECOMPUTED_TRANSFORM_READER_DIR
   ${IGSTK_SOURCE_DIR}/Examples/TransformReaders
)

SET(TRACKER_CONFIGURATION_DIR
   ${IGSTK_SOURCE_DIR}/Examples/TrackerConfiguration
)

SET(TRACKER_CONFIGURATION_READER_DIR
   ${IGSTK_SOURCE_DIR}/Examples/TrackerConfiguration/configurationFileReaders
)

 
INCLUDE_DIRECTORIES(
  ${OpenIGTLinkConfigurationReaders_SOURCE_DIR}
  ${OpenIGTLinkConfigurationReaders_BINARY_DIR}
  ${TRACKER_CONFIGURATION_DIR}
  ${TRACKER_CONFIGURATION_READER_DIR}
  ${PRECOMPUTED_TRANSFORM_READER_DIR}
  )

SET(OpenIGTLinkConfigurationReaders_SRCS
  igstkOpenIGTLinkTrackerConfigurationXMLFileReader.cxx
  igstkOpenIGTLinkTrackerConfigurationFileReader.cxx
)

ADD_LIBRARY(OpenIGTLinkConfigurationReaders ${OpenIGTLinkConfigurationReaders_SRCS} )
TARGET_LINK_LIBRARIES(OpenIGTLinkConfigurationReaders TrackerConfiguration TransformReaders IGSTK)

=== Examples/OpenIGTLinkTrackerBroadcasting/CMakeLists.txt ===
PROJECT(OpenIGTLinkTrackerBroadcasting)

SET(PRECOMPUTED_TRANSFORM_READER_DIR
    ${IGSTK_SOURCE_DIR}/Examples/TransformReaders
)

SET(TRACKER_CONFIGURATION_DIR
    ${IGSTK_SOURCE_DIR}/Examples/TrackerConfiguration
)

SET(TRACKER_CONFIGURATION_READERS_DIR
    ${IGSTK_SOURCE_DIR}/Examples/TrackerConfiguration/configurationFileReaders
)

SET(OpenIGTLINK_CONFIGURATION_READERS_DIR
    ${IGSTK_SOURCE_DIR}/Examples/OpenIGTLinkConfigurationReaders
)



#
# Source code for the project
#
SET(SRCS
    OpenIGTLinkTrackingBroadcaster.cxx
)
SET(HDRS
    OpenIGTLinkTrackingBroadcaster.h
)

#
# Include directories.
# Project's binary directory is part of the includes because cmake runs the fluid
# "compiler" on the *.fl GUI description files to generate
# *.cxx, *.h files which are written into the binary directory.
#

INCLUDE_DIRECTORIES(
${TRACKER_CONFIGURATION_DIR}
${TRACKER_CONFIGURATION_READERS_DIR}
${OpenIGTLINK_CONFIGURATION_READERS_DIR}
${PRECOMPUTED_TRANSFORM_READER_DIR}
${IGSTK_INCLUDE_DIR}
${OpenIGTLinkTrackerBroadcasting_SOURCE_DIR}
${OpenIGTLinkTrackerBroadcasting_BINARY_DIR}
)

IF(IGSTK_USE_FLTK)

  #
  # FLTK fluid GUI files for project
  #
  SET(OpenIGTLinkTrackerBroadcasting_GUI_SRCS
      OpenIGTLinkTrackingBroadcasterGUI.fl
    )

  FLTK_WRAP_UI(OpenIGTLinkTrackerBroadcastingUI ${OpenIGTLinkTrackerBroadcasting_GUI_SRCS})
  ADD_EXECUTABLE(OpenIGTLinkTrackerBroadcastingUI OpenIGTLinkTrackingBroadcasterMainFLTK.cxx ${SRCS} ${HDRS} ${OpenIGTLinkTrackerBroadcastingUI_FLTK_UI_SRCS})  
  TARGET_LINK_LIBRARIES(OpenIGTLinkTrackerBroadcastingUI TrackerConfiguration OpenIGTLinkConfigurationReaders IGSTK)
  
ENDIF(IGSTK_USE_FLTK)

ADD_EXECUTABLE(OpenIGTLinkTrackerBroadcasting OpenIGTLinkTrackingBroadcasterMainCommandLine.cxx ${SRCS} ${HDRS})
TARGET_LINK_LIBRARIES(OpenIGTLinkTrackerBroadcasting TrackerConfiguration OpenIGTLinkConfigurationReaders IGSTK)

=== Examples/TrackerConfiguration/CMakeLists.txt ===
PROJECT(TrackerConfiguration)

SET(PRECOMPUTED_TRANSFORM_READER_DIR
   ${IGSTK_SOURCE_DIR}/Examples/TransformReaders
)

#
# Source code for the project
#
SET(SRCS
    igstkTrackerConfiguration.cxx
    igstkAuroraTrackerConfiguration.cxx
    igstkMicronTrackerConfiguration.cxx
    igstkAscensionTrackerConfiguration.cxx
    igstkPolarisTrackerConfiguration.cxx
    igstkTrackerController.cxx
    configurationFileReaders/igstkTrackerConfigurationXMLFileReaderBase.cxx
    configurationFileReaders/igstkSerialCommunicatingTrackerConfigurationXMLFileReader.cxx
    configurationFileReaders/igstkPolarisWirelessConfigurationXMLFileReader.cxx
    configurationFileReaders/igstkPolarisVicraConfigurationXMLFileReader.cxx
    configurationFileReaders/igstkPolarisSpectraConfigurationXMLFileReader.cxx
    configurationFileReaders/igstkPolarisHybridConfigurationXMLFileReader.cxx
    configurationFileReaders/igstkAuroraConfigurationXMLFileReader.cxx
    configurationFileReaders/igstkMicronConfigurationXMLFileReader.cxx
    configurationFileReaders/igstkAscensionConfigurationXMLFileReader.cxx
    configurationFileReaders/igstkTrackerConfigurationFileReader.cxx
)
SET(HDRS
    igstkTrackerConfiguration.h
    igstkAuroraTrackerConfiguration.h
    igstkMicronTrackerConfiguration.h
    igstkAscensionTrackerConfiguration.h
    igstkPolarisTrackerConfiguration.h
    igstkTrackerController.h
    configurationFileReaders/igstkTrackerConfigurationXMLFileReaderBase.h
    configurationFileReaders/igstkSerialCommunicatingTrackerConfigurationXMLFileReader.h
    configurationFileReaders/igstkPolarisWirelessConfigurationXMLFileReader.h
    configurationFileReaders/igstkPolarisVicraConfigurationXMLFileReader.h
    configurationFileReaders/igstkPolarisSpectraConfigurationXMLFileReader.h
    configurationFileReaders/igstkPolarisHybridConfigurationXMLFileReader.h
    configurationFileReaders/igstkAuroraConfigurationXMLFileReader.h
    configurationFileReaders/igstkMicronConfigurationXMLFileReader.h
    configurationFileReaders/igstkAscensionConfigurationXMLFileReader.h
    configurationFileReaders/igstkTrackerConfigurationFileReader.h
)
#
#The directories containing all of the header files
#
INCLUDE_DIRECTORIES(
 ${PRECOMPUTED_TRANSFORM_READER_DIR}
 .
 ./configurationFileReaders
)

ADD_LIBRARY(TrackerConfiguration ${SRCS} ${HDRS})
TARGET_LINK_LIBRARIES(TrackerConfiguration IGSTK)

ADD_EXECUTABLE(TrackerConfigurationExample TrackerConfigurationExample.cxx)
TARGET_LINK_LIBRARIES(TrackerConfigurationExample TrackerConfiguration TransformReaders IGSTK)

=== Examples/TransformWriters/CMakeLists.txt ===
PROJECT(TransformWriters)
#
# Source code for the project
#
SET(SRCS
    igstkTransformXMLFileWriterBase.cxx
    igstkRigidTransformXMLFileWriter.cxx
    igstkAffineTransformXMLFileWriter.cxx
    igstkTransformFileWriter.cxx
)
SET(HDRS
    igstkTransformXMLFileWriterBase.h
    igstkRigidTransformXMLFileWriter.h
    igstkAffineTransformXMLFileWriter.h
    igstkTransformFileWriter.h
)

INCLUDE_DIRECTORIES(
${IGSTK_SOURCE_DIR}/Examples/TransformReaders
.
)

ADD_LIBRARY( TransformWriters ${SRCS} ${HDRS})
TARGET_LINK_LIBRARIES(TransformWriters  TransformReaders IGSTK)

ADD_EXECUTABLE(TransformWriterExample TransformWriterExample.cxx) 
TARGET_LINK_LIBRARIES(TransformWriterExample TransformWriters IGSTK)

=== Utilities/SceneGraphVisualization/CMakeLists.txt ===
PROJECT(SceneGraphVisualization)

SET(SceneGraphVisualization_SRC
    igstkSceneGraph.cxx
    igstkSceneGraph.h
    igstkSceneGraphNode.cxx
    igstkSceneGraphNode.h
    igstkSceneGraphObserver.h
)

IF (IGSTK_USE_FLTK)
  SET(SceneGraphVisualization_SRC
      ${SceneGraphVisualization_SRC}
      igstkSceneGraphUI.cxx
      igstkSceneGraphUI.h
      )
ENDIF (IGSTK_USE_FLTK)

INCLUDE_DIRECTORIES(
  ${SceneGraphVisualization_SOURCE_DIR}
  ${SceneGraphVisualization_BINARY_DIR}
  )
  
ADD_LIBRARY(SceneGraphVisualization ${SceneGraphVisualization_SRC} )
TARGET_LINK_LIBRARIES(SceneGraphVisualization IGSTK)

=== Utilities/MicronTracker/src/CMakeLists.txt ===
# Add proper includes
INCLUDE_DIRECTORIES(
  ${MTC_INCLUDE_DIRECTORY}
)

SET( SOURCES
  Cameras.cpp
  Collection.cpp
  Facet.cpp 
  MCamera.cpp
  Marker.cpp
  Markers.cpp
  Persistence.cpp
  Vector.cpp
  Xform3D.cpp
  )

ADD_LIBRARY(igstkMTCu ${SOURCES})
TARGET_LINK_LIBRARIES( igstkMTCu MTC )

=== debian/changelog ===
igstk (4.2.0-4) unstable; urgency=low

  [ Andreas Tille ]
  * debian/patches/gcc-4.5.patch (Closes: #565002)
  * Standards-Version: 3.9.1 (no changes needed)
  * debian/source/format: 3.0 (quilt)

  [ Dominique Belhachemi ]
  * Added build dependency libqtwebkit-dev

 -- Dominique Belhachemi <domibel@debian.org>  Mon, 14 Mar 2011 21:37:04 -0400

igstk (4.2.0-3) unstable; urgency=low

  [ Dominique Belhachemi ]
  * Link with --no-add-needed option (Closes: #554864)
  * Add build deps: libavcodec-dev, libavformat-dev, and libswscale-dev.
  * Remove FindOpenCV.cmake.
  * Tweak patches 90_examples.diff and 05_cvs20090823.diff.
  
  [ Steve M. Robbins ]
  * Add missing build dependencies for libgl2ps-dev, mpi-default-dev, and
    libmysqlclient-dev (Closes: #562299).
  * Add ${misc:Depends} to libigstk4-dev and igstk-examples.  Restore
    README.source.

 -- Steve M. Robbins <smr@debian.org>  Tue, 05 Jan 2010 21:08:29 -0600

igstk (4.2.0-2) unstable; urgency=low

  * Fixed link issue (Closes: #549799)
  * switch to quilt

 -- Dominique Belhachemi <domibel@cs.tu-berlin.de>  Wed, 07 Oct 2009 17:35:43 -0400

igstk (4.2.0-1) unstable; urgency=low

  * new release
  * upload to unstable

 -- Dominique Belhachemi <domibel@cs.tu-berlin.de>  Mon, 24 Aug 2009 15:12:48 -0400

igstk (4.2.0~cvs20090616-1) experimental; urgency=low

  * new upstream snapshot
  * soname bump
  * OpenIGTLink support enabled

 -- Dominique Belhachemi <domibel@cs.tu-berlin.de>  Thu, 11 Jun 2009 19:24:49 -0400

igstk (3.0.0~cvs20090203-1) experimental; urgency=low

  * new upstream snapshot
  * uses "dh_prep" now instead of "dh_clean -k"

 -- Dominique Belhachemi <domibel@cs.tu-berlin.de>  Wed, 04 Feb 2009 11:29:55 -0500

igstk (3.0.0~cvs20081223-2) unstable; urgency=low

  * debian/rules: removed duplicate configuration
  * debian/rules: fixed installation of Examples
  * debian/control: added new package : igstk-doc
  * debian/igstk-doc.doc-base: added

 -- Dominique Belhachemi <domibel@cs.tu-berlin.de>  Sun, 28 Dec 2008 19:11:43 -0500

igstk (3.0.0~cvs20081223-1) experimental; urgency=low

  * debian/libigstk3.symbols removed
  * ctest disabled

 -- Dominique Belhachemi <domibel@cs.tu-berlin.de>  Tue, 23 Dec 2008 18:43:29 -0500

igstk (3.0.0~cvs20081217-1) experimental; urgency=low

  * new upstream snapshot

 -- Dominique Belhachemi <domibel@cs.tu-berlin.de>  Thu, 18 Dec 2008 14:13:24 -0500

igstk (3.0.0~cvs20080716-1) unstable; urgency=low

  * Initial release (Closes: #490627)

 -- Dominique Belhachemi <domibel@cs.tu-berlin.de>  Tue, 24 Jun 2008 20:51:56 +0200

=== debian/control ===
Source: igstk
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
DM-Upload-Allowed: yes
Uploaders: Dominique Belhachemi <domibel@cs.tu-berlin.de>, Steve M. Robbins <smr@debian.org>,
 Andreas Tille <tille@debian.org>
Build-Depends: debhelper (>= 7), quilt, cmake, libinsighttoolkit3-dev (>= 3.16), libvtk5-dev,
 zlib1g-dev, libfreetype6-dev, libxext-dev, libpng-dev, libjpeg-dev, libtiff-dev,
 libexpat1-dev, libqt4-dev, libvtk5-qt4-dev, libfltk1.1-dev, fluid, uuid-dev,
 libxss-dev, libxft-dev, libopenigtlink1-dev, libgdcm2-dev, libssl-dev, libopenjpeg-dev,
 libavcodec-dev, libavformat-dev, libswscale-dev, libgl2ps-dev, mpi-default-dev, libmysqlclient-dev,
 libqtwebkit-dev [ia64 sparc i386 amd64] 
Build-Depends-Indep: doxygen, graphviz
Standards-Version: 3.9.1
Vcs-Browser: http://svn.debian.org/wsvn/debian-med/trunk/packages/igstk/trunk/?rev=0&sc=0
Vcs-Svn: svn://svn.debian.org/svn/debian-med/trunk/packages/igstk/trunk/
Section: libs
Homepage: http://www.igstk.org


Package: libigstk4-dev
Section: libdevel
Architecture: any
Depends: libigstk4 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}, libinsighttoolkit3-dev, libvtk5-dev
Suggests: libqt4-dev, libvtk5-qt4-dev, libfltk1.1-dev
Description: Toolkit for image-guided surgery applications - development
 The Image-Guided Surgery Toolkit (IGstk: pronounced IGStick) is a
 high-level component-based framework providing common functionality
 for image-guided surgery applications.
 .
 This software framework consists of a set of high-level components
 integrated with other low-level open source software libraries and
 application programming interfaces (API) from hardware vendors.
 .
 The cornerstone of IGstk is robustness. IGstk provides the following
 high-level functionality:
 Ability to read and display medical images including CT and MRI in
 DICOM format.
 An interface to common tracking hardware (e.g. AURORA from
 Northern Digital Inc.). A graphical user interface and visualization
 capability including a four-quadrant view (axial, sagittal, coronal,
 and 3D) as well as a multi-slice axial view (from 1 by 1 to many by
 many such as 10 by 10).
 .
 Registration: point based registration and a means for selecting
 these points. Robust common internal software services for logging,
 exception-handling and problem resolution.
 .
 This package contains the development files needed to build
 your own IGSTK applications.


Package: libigstk4
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Toolkit for image-guided surgery applications - runtime
 The Image-Guided Surgery Toolkit (IGstk: pronounced IGStick) is a
 high-level component-based framework providing common functionality
 for image-guided surgery applications.
 .
 This software framework consists of a set of high-level components
 integrated with other low-level open source software libraries and
 application programming interfaces (API) from hardware vendors.
 .
 The cornerstone of IGstk is robustness. IGstk provides the following
 high-level functionality:
 Ability to read and display medical images including CT and MRI in
 DICOM format.
 .
 An interface to common tracking hardware (e.g. AURORA from
 Northern Digital Inc.). A graphical user interface and visualization
 capability including a four-quadrant view (axial, sagittal, coronal,
 and 3D) as well as a multi-slice axial view (from 1 by 1 to many by
 many such as 10 by 10).
 .
 Registration: point based registration and a means for selecting
 these points. Robust common internal software services for logging,
 exception-handling and problem resolution.


Package: igstk-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Toolkit for image-guided surgery applications - documentation
 The Image-Guided Surgery Toolkit (IGstk: pronounced IGStick) is a
 high-level component-based framework providing common functionality
 for image-guided surgery applications.
 .
 This software framework consists of a set of high-level components
 integrated with other low-level open source software libraries and
 application programming interfaces (API) from hardware vendors.
 .
 The cornerstone of IGstk is robustness. IGstk provides the following
 high-level functionality:
 Ability to read and display medical images including CT and MRI in
 DICOM format.
 .
 An interface to common tracking hardware (e.g. AURORA from
 Northern Digital Inc.). A graphical user interface and visualization
 capability including a four-quadrant view (axial, sagittal, coronal,
 and 3D) as well as a multi-slice axial view (from 1 by 1 to many by
 many such as 10 by 10).
 .
 Registration: point based registration and a means for selecting
 these points. Robust common internal software services for logging,
 exception-handling and problem resolution.
 .
 This package contains documentation files for IGstk.


Package: igstk-examples
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: libigstk4-dev
Description: Toolkit for image-guided surgery applications - examples
 The Image-Guided Surgery Toolkit (IGstk: pronounced IGStick) is a
 high-level component-based framework providing common functionality
 for image-guided surgery applications.
 .
 This software framework consists of a set of high-level components
 integrated with other low-level open source software libraries and
 application programming interfaces (API) from hardware vendors.
 .
 The cornerstone of IGstk is robustness. IGstk provides the following
 high-level functionality:
 Ability to read and display medical images including CT and MRI in
 DICOM format.
 An interface to common tracking hardware (e.g. AURORA from
 Northern Digital Inc.). A graphical user interface and visualization
 capability including a four-quadrant view (axial, sagittal, coronal,
 and 3D) as well as a multi-slice axial view (from 1 by 1 to many by
 many such as 10 by 10).
 .
 Registration: point based registration and a means for selecting
 these points. Robust common internal software services for logging,
 exception-handling and problem resolution.
 .
 This package contains examples from the IGstk source.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=0

include /usr/share/quilt/quilt.make

STATIC_BUILD_PATH = DEB_build_static
SHARED_BUILD_PATH = DEB_build_shared

CMAKE_FLAGS = -DCMAKE_INSTALL_PREFIX:PATH=/usr \
              -DCMAKE_CXX_FLAGS="-Wno-deprecated" \
              -DCMAKE_VERBOSE_MAKEFILE=$(DH_VERBOSE) \
              -DCMAKE_SHARED_LINKER_FLAGS="-Wl,--as-needed,--no-add-needed" \
              -DCMAKE_EXE_LINKER_FLAGS="-Wl,--as-needed,--no-add-needed" \
              -DCMAKE_SKIP_RPATH:BOOL=ON \
              -DIGSTK_WITH_LIBRARY_VERSION:BOOL=ON \
              -DIGSTK_DEVELOPMENT_VERSION:BOOL=ON \
              -DIGSTK_BUILD_EXAMPLES:BOOL=OFF \
              -DIGSTK_BUILD_TESTING:BOOL=ON \
              -DCMAKE_BUILD_TYPE:STRING=Release \
              -DIGSTK_USE_Qt:BOOL=ON \
              -DIGSTK_USE_FLTK:BOOL=ON \
              -DIGSTK_USE_OpenIGTLink:BOOL=ON \
              -DIGSTK_USE_OpenCV:BOOL=OFF \
              -DIGSTK_USE_MicronTracker:BOOL=OFF \
              -DQT_MOC_EXECUTABLE:PATH=/usr/bin/moc-qt4 \
              -DQT_UIC_EXECUTABLE:PATH=/usr/bin/uic-qt4 \
              -DQT_QMAKE_EXECUTABLE:PATH=/usr/bin/qmake
              

# if using precompiled static library provided by Claron Tech.:
#              -DIGSTK_USE_MicronTracker:BOOL=ON \
#              -DMTC_INCLUDE_DIRECTORY:PATH=/tmp/MTC/Dist \
#              -DMTC_LIBRARY:PATH=/tmp/MTC/Dist \ 
# TODO: /usr/bin/ld: cannot find -lMTC \

# set the number of build jobs
#ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
#        JOBS := -j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
#endif

get-orig-source:
	/bin/sh $(CURDIR)/debian/get-orig-source


configure: configure-stamp
configure-stamp: $(QUILT_STAMPFN)
	dh_testdir

	if [ ! -d $(STATIC_BUILD_PATH) ]; then mkdir $(STATIC_BUILD_PATH); fi

	cd $(STATIC_BUILD_PATH) \
            && cmake $(CURDIR) $(CMAKE_FLAGS) -DBUILD_SHARED_LIBS:BOOL=OFF -DBUILD_DOCUMENTATION:BOOL=ON

	if [ ! -d $(SHARED_BUILD_PATH) ]; then mkdir $(SHARED_BUILD_PATH); fi

	cd $(SHARED_BUILD_PATH) \
            && cmake $(CURDIR) $(CMAKE_FLAGS) -DBUILD_SHARED_LIBS:BOOL=ON

	touch configure-stamp


build: build-arch

build-arch: build-arch-stamp
build-arch-stamp: configure-stamp
	dh_testdir
	dh_prep

	# Add here commands to compile the package.

        # build static libs
	$(MAKE) $(JOBS) -C $(STATIC_BUILD_PATH)

        # build shared libs
	$(MAKE) $(JOBS) -C $(SHARED_BUILD_PATH)

        # perform tests ('-' ignores return values)
#       cd $(STATIC_BUILD_PATH) && ctest -S ../debian/ctest_config.cmake -VV
#       - cd $(STATIC_BUILD_PATH) && ctest -D Nightly -VV
	- cd $(STATIC_BUILD_PATH) && ctest

	touch $@

build-indep: build-indep-stamp
build-indep-stamp: configure-stamp
	dh_testdir

	# build documentation
	mkdir -p $(STATIC_BUILD_PATH)/Utilities/Doxygen/doc/html
	$(MAKE) $(JOBS) Documentation -C $(STATIC_BUILD_PATH)

	# remove zero byte files
	find $(STATIC_BUILD_PATH)/Utilities/Doxygen/doc/ -depth -empty | xargs rm -rf

	touch $@


clean: clean-patched unpatch

clean-patched:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp build-arch-stamp

	# Add here commands to clean up after the build process.
	rm -rf $(STATIC_BUILD_PATH)
	rm -rf $(SHARED_BUILD_PATH)
	rm -rf debian/tmp2

	dh_clean 


install-arch: build-arch
	dh_testdir
	dh_testroot
	dh_installdirs

        # install binaries and static libs
	cd $(STATIC_BUILD_PATH) && $(MAKE) install DESTDIR=$(CURDIR)/debian/tmp
	cd $(SHARED_BUILD_PATH) && $(MAKE) install DESTDIR=$(CURDIR)/debian/tmp2


	# install development files
	dh_install -plibigstk4-dev    debian/tmp/usr/include/IGSTK/*                       usr/include/IGSTK
#	dh_install -plibigstk4-dev    ../../Utilities/SceneGraphVisualization/igstk*.h     usr/include/IGSTK

	# install libs and *cmake files
	dh_install -plibigstk4-dev  debian/tmp/usr/lib/IGSTK/*.a      usr/lib
	dh_install -plibigstk4-dev  $(SHARED_BUILD_PATH)/bin/*.so     usr/lib
	dh_install -plibigstk4-dev  debian/tmp/usr/lib/IGSTK/*.cmake  usr/lib/IGSTK

	dh_install -plibigstk4      $(SHARED_BUILD_PATH)/bin/*.so.*   usr/lib


install-indep: build-indep
	dh_install -pigstk-doc      $(STATIC_BUILD_PATH)/Utilities/Doxygen/doc/html       usr/share/doc/igstk-doc
	dh_installexamples -pigstk-examples Examples/*

	# remove executable file mode bit
	find debian/igstk-examples/usr/share/doc/igstk-examples/examples \
            -type f -print0 | xargs -0 chmod 644


# Build architecture independant packages using the common target.
binary-indep: install-indep
	$(MAKE) -f debian/rules DH_OPTIONS=-i binary-common


# Build architecture dependant packages using the common target.
binary-arch: install-arch
	$(MAKE) -f debian/rules DH_OPTIONS=-s binary-common


# Build architecture-dependent files here.
binary-common:
	dh_testdir
	dh_testroot
	dh_install
	dh_installchangelogs 
	dh_installdocs
	dh_installman
	dh_link
	dh_strip
	dh_compress -X"igstk-examples/examples"
	dh_fixperms
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install install-indep install-arch configure
